attribute vec4 position;
attribute vec4 inputTextureCoordinate;

const int GAUSSIAN_SAMPLES = 9;

uniform float texelWidthOffset;
uniform float texelHeightOffset;

uniform   mat4 uPosMtx;
uniform   mat4 uTexMtx;

varying vec2 textureCoordinate;

void main()
{
    gl_Position = uPosMtx * position;
    textureCoordinate = (uTexMtx * inputTextureCoordinate).xy;
}