precision highp float;

uniform sampler2D 	tex0;
uniform sampler2D 	tex1;
varying vec2 UV;
varying vec2 UV1;
varying vec2 UV2;

//const mat3 yuvToRgb = mat3(1,  1, 1,
//                           0.0,   -0.39465, 2.03211,
//                           1.13983, -0.58060, 0.0);
//const mat3 rgbToYuv = mat3(0.299, -0.14713,0.615,
//                           0.587, -0.28886, -0.51499,
//                           0.114, 0.436, -0.10001);

//vec3 rgb2hsv(vec3 c)
//{
//    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
//    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
//    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));
//
//    float d = q.x - min(q.w, q.y);
//    float e = 1.0e-10;
//    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
//}
//
//// All components are in the range [0…1], including hue.
//vec3 hsv2rgb(vec3 c)
//{
//    vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
//    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
//    return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
//}

void main()
{
    vec4 origin = texture2D(tex0,UV1);
    vec4 dst = texture2D(tex0,UV);
    vec4 mask = texture2D(tex1,UV2);
//
//    vec3 originYuv = rgbToYuv * origin.rgb + vec3(0.0625,0.5,0.5);
//    vec3 dstYuv = rgbToYuv * dst.rgb + vec3(0.0625,0.5,0.5) ;
//
//    dstYuv.r = originYuv.r;
//    vec3 dstColor = yuvToRgb * (dstYuv  - vec3(0.0625,0.5,0.5));

//    vec3 originHsv = rgb2hsv(origin.rgb);
//    vec3 dstHsv = rgb2hsv(dst.rgb);

//    dstHsv.r = originHsv.r;

//    vec3 dstColor = hsv2rgb(dstHsv);
    vec3 dstColor = dst.rgb;

    vec3 dstOut = dstColor * mask.a + origin.rgb * (1. - mask.a);

	gl_FragColor = vec4(dstOut,1.0);//vec4(dstColor,1.0);
}