precision highp float;

uniform mat4 InvWorldView;
uniform mat4 Proj;

attribute vec4 aVertexCo;
attribute vec2 aTextureCo;

varying vec3 UV;

void main()
{
	vec4 vPos;
	vPos.xy = aTextureCo * 2.0 - vec2( 1.0 );	
	vPos.z = 0.999;
	vPos.w = 1.0;
	vec4 vTex = Proj * vPos;
	vTex.xyz = vTex.xyz / vTex.w;
	vTex.w = 0.0;
	vTex =  InvWorldView * vTex;
	UV = vTex.xyz;
	gl_Position = vPos;
}
